"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Xception = void 0;

var _stack = require("./stack");

/*
 *                            *** MIT LICENSE ***
 * -------------------------------------------------------------------------
 * This code may be modified and distributed under the MIT license.
 * See the LICENSE file for details.
 * -------------------------------------------------------------------------
 *
 * @summary
 *
 * @author    Alvis HT Tang <alvis@hilbert.space>
 * @license   MIT
 * @copyright Copyright (c) 2020 - All Rights Reserved.
 * -------------------------------------------------------------------------
 */

/** a high-order error that combine previous stack and tags */
class Xception extends Error {
  /** upstream error */

  /** error namespace */

  /** running context */

  /** additional associations */

  /**
   * @param message error message
   * @param options additional options for the error
   * @param options.cause upstream error
   * @param options.namespace namespace of the error
   * @param options.meta context where the error occur
   * @param options.tags additional associations for the error
   */
  constructor(message, options) {
    const {
      cause,
      namespace,
      meta = {},
      tags = []
    } = { ...options
    };
    super(message);
    this.cause = void 0;
    this.namespace = void 0;
    this.meta = void 0;
    this.tags = void 0;
    this.cause = cause;
    this.namespace = namespace;
    this.meta = meta; // fix the name of the error class being 'Error'

    this.name = this.constructor.name; // enrich the stack

    this.stack = cause instanceof Error && cause.stack && this.stack ? [// the error message and the location where the error is formed
    (0, _stack.assembleStack)((0, _stack.disassembleStack)(this.stack).slice(0, // description + location
    1 + 1)), cause.stack].join('\n') : this.stack; // attach tags to the error

    this.tags = cause instanceof Xception ? [...cause.tags, ...tags] : tags;
  }

}

exports.Xception = Xception;
//# sourceMappingURL=prototype.js.map